//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int Length = 32;
extern int Price  = PRICE_TYPICAL;

double cg[];
double storaw[];
double stocg[];
double stocgda[];
double stocgdb[];
double stosig[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,stocgda); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,stocgdb); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,stocg);
      SetIndexBuffer(3,stosig);
      SetIndexBuffer(4,cg);
      SetIndexBuffer(5,storaw);
      SetIndexBuffer(6,trend);
   return(0); 
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double num = 0;
      double den = 0;
         for (int k=0; k<Length; k++)
         {
            double price = iMA(NULL,0,1,0,MODE_SMA,Price,i+k);
                   num += price*(k+1);
                   den += price;
         }
         if (den!=0)
               cg[i] = -num/den+(Length+1)/2.0;
         else  cg[i] = 0;
         
         //
         //
         //
         //
         //
         
         double hh = cg[ArrayMaximum(cg,Length,i)];          
         double ll = cg[ArrayMinimum(cg,Length,i)];
         if (hh!=ll)
               storaw[i] = (cg[i]-ll)/(hh-ll);
         else  storaw[i] = 0;
         double smtcg = (4.0*storaw[i]+3.0*storaw[i+1]+2.0*storaw[i+2]+storaw[i+3])/10.0;
         
         //
         //
         //
         //
         //
         
            stocg[i]   = 2.0*(smtcg-0.5);
            stosig[i]  = 0.96*(stocg[i+1] + 0.02);
            stocgda[i] = EMPTY_VALUE;
            stocgdb[i] = EMPTY_VALUE;
            trend[i]   = trend[i+1];
               if (stocg[i]>stosig[i]) trend[i] =  1;
               if (stocg[i]<stosig[i]) trend[i] = -1;
               if (trend[i]== 1) stocgda[i] = 1;
               if (trend[i]==-1) stocgdb[i] = 1;
   }
   return(0);
}


